# coding: utf-8

"""
    Pluggy API

    Pluggy's main API to review data and execute connectors

    The version of the OpenAPI document: 1.0.0
    Contact: hello@pluggy.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from pluggy_sdk.models.schedule_type_custom import ScheduleTypeCustom
from pluggy_sdk.models.schedule_type_daily import ScheduleTypeDaily
from pluggy_sdk.models.schedule_type_monthly import ScheduleTypeMonthly
from pluggy_sdk.models.schedule_type_single import ScheduleTypeSingle
from pluggy_sdk.models.schedule_type_weekly import ScheduleTypeWeekly
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

PAYMENTREQUESTSCHEDULE_ONE_OF_SCHEMAS = ["ScheduleTypeCustom", "ScheduleTypeDaily", "ScheduleTypeMonthly", "ScheduleTypeSingle", "ScheduleTypeWeekly"]

class PaymentRequestSchedule(BaseModel):
    """
    PaymentRequestSchedule
    """
    # data type: ScheduleTypeSingle
    oneof_schema_1_validator: Optional[ScheduleTypeSingle] = None
    # data type: ScheduleTypeDaily
    oneof_schema_2_validator: Optional[ScheduleTypeDaily] = None
    # data type: ScheduleTypeWeekly
    oneof_schema_3_validator: Optional[ScheduleTypeWeekly] = None
    # data type: ScheduleTypeMonthly
    oneof_schema_4_validator: Optional[ScheduleTypeMonthly] = None
    # data type: ScheduleTypeCustom
    oneof_schema_5_validator: Optional[ScheduleTypeCustom] = None
    actual_instance: Optional[Union[ScheduleTypeCustom, ScheduleTypeDaily, ScheduleTypeMonthly, ScheduleTypeSingle, ScheduleTypeWeekly]] = None
    one_of_schemas: Set[str] = { "ScheduleTypeCustom", "ScheduleTypeDaily", "ScheduleTypeMonthly", "ScheduleTypeSingle", "ScheduleTypeWeekly" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = PaymentRequestSchedule.model_construct()
        error_messages = []
        match = 0
        # validate data type: ScheduleTypeSingle
        if not isinstance(v, ScheduleTypeSingle):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ScheduleTypeSingle`")
        else:
            match += 1
        # validate data type: ScheduleTypeDaily
        if not isinstance(v, ScheduleTypeDaily):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ScheduleTypeDaily`")
        else:
            match += 1
        # validate data type: ScheduleTypeWeekly
        if not isinstance(v, ScheduleTypeWeekly):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ScheduleTypeWeekly`")
        else:
            match += 1
        # validate data type: ScheduleTypeMonthly
        if not isinstance(v, ScheduleTypeMonthly):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ScheduleTypeMonthly`")
        else:
            match += 1
        # validate data type: ScheduleTypeCustom
        if not isinstance(v, ScheduleTypeCustom):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ScheduleTypeCustom`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in PaymentRequestSchedule with oneOf schemas: ScheduleTypeCustom, ScheduleTypeDaily, ScheduleTypeMonthly, ScheduleTypeSingle, ScheduleTypeWeekly. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in PaymentRequestSchedule with oneOf schemas: ScheduleTypeCustom, ScheduleTypeDaily, ScheduleTypeMonthly, ScheduleTypeSingle, ScheduleTypeWeekly. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into ScheduleTypeSingle
        try:
            instance.actual_instance = ScheduleTypeSingle.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ScheduleTypeDaily
        try:
            instance.actual_instance = ScheduleTypeDaily.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ScheduleTypeWeekly
        try:
            instance.actual_instance = ScheduleTypeWeekly.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ScheduleTypeMonthly
        try:
            instance.actual_instance = ScheduleTypeMonthly.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ScheduleTypeCustom
        try:
            instance.actual_instance = ScheduleTypeCustom.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into PaymentRequestSchedule with oneOf schemas: ScheduleTypeCustom, ScheduleTypeDaily, ScheduleTypeMonthly, ScheduleTypeSingle, ScheduleTypeWeekly. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into PaymentRequestSchedule with oneOf schemas: ScheduleTypeCustom, ScheduleTypeDaily, ScheduleTypeMonthly, ScheduleTypeSingle, ScheduleTypeWeekly. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], ScheduleTypeCustom, ScheduleTypeDaily, ScheduleTypeMonthly, ScheduleTypeSingle, ScheduleTypeWeekly]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


